# This is the MSC 4.0 and higher OS/2 configuration file for DMAKE
#	It simply modifies the values of SRC, and checks to see if
#	OSENVIRONMENT is defined.  If so it includes the appropriate
#	config.mk file.
#
# It also sets the values of .SOURCE.c and .SOURCE.h to include the local
# directory.
#
osrdir := $(OS)$(DIRSEPSTR)$(OSRELEASE)

# Definition of macros for library, and C startup code.

# The following sources are required for MSC
OSR_SRC = tempnam.c
.SETDIR=$(osrdir) : $(OSR_SRC)

SRC += $(OSR_SRC)
.SOURCE.h : $(osrdir)

# Local configuration modifications for CFLAGS 
# OS/2 always has at least a 286 so this is enabled by default:
CFLAGS += /oaxte=100

SET_STACK = /stack:8192
NDB_LDFLAGS += $(SET_STACK)

# Microsoft C doesn't need tail but needs head
LDTAIL = $(OS)$(DIRSEPSTR)$(TARGET:b).def;
LDHEAD = $(LDFLAGS)

# Debugging libraries
DB_LDFLAGS += /co /li /map $(SET_STACK)
DB_LDLIBS  +=

# NO Debug MSC flags:
# Set the environment variable MSC_VER to be one of 4.0, 5.0, 5.1, or 6.0
# to get these by default when you make dmake using 'dmake'.
#
# Setting MSC_VER to one of the above sets the variable _MSC_VER appropriately
# and sets the flags appropriately.

.IMPORT .IGNORE : MSC_VER
MSC_VER *= 6.0			  # If unset, assume 6.0 by default.

CFLAGS      += -I$(osrdir)
CFLAGS      += -DM_I86=1       # 5.0+ define this automatically
CFLAGS      += -D__STDC__=1    # 5.0, 5.1, but not 6.0 do this automatically
NDB_CFLAGS  +=
DB_CFLAGS   += /d2

# See if we modify anything in the lower levels.
.IF $(OSENVIRONMENT) != $(NULL)
   .INCLUDE .IGNORE : $(osrdir)$(DIRSEPSTR)$(OSENVIRONMENT)$(DIRSEPSTR)config.mk
.END

